package de.snailshell.consensus.demo.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import de.snailshell.consensus.demo.Constants;
import de.uka.ipd.consensus.foundation.ontology.OntologyManager;
import de.uka.ipd.consensus.foundation.schema.Rating;
import de.uka.ipd.consensus.foundation.schema.Topic;
import de.uka.ipd.consensus.foundation.schema.User;

/**
 * @author Thomas Much
 * @version 2006-06-14
 */
public class ChangeTopicRatingAction extends BasisAction {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		if (!isUserLoggedOn(request)) {
			return mapping.findForward( Constants.MAPPING_FAILURE );
		}

		String id        = request.getParameter("id");
		String ratingstr = ((DynaActionForm)form).getString("topicrating");
		String comment   = ((DynaActionForm)form).getString("ratingcomment");
		
		double value;
		
		if (this.getRatingManager() != null) {
			value = this.getRatingManager().stringToRatingValue( ratingstr );
		}
		else {
			value = Rating.NEUTRAL;
		}

		OntologyManager om = this.getOntologyManager();
		
		User user = this.getUser(request);
		
		Topic t = om.getQueryEngine().getTopicById( user, id );
		
		Rating r = t.addRating( user, value );
		
		r.setComment( user, comment );

		this.getLoggingManager().debug("Change rating for " + t + " to " + ratingstr + "/" + value + " (by " + user + ")");

		request.setAttribute( Constants.REQUEST_ATTR_TOPIC, t );

		return mapping.findForward( Constants.MAPPING_SUCCESS );
	}
}
